/**
 * @name string-remove-duplicate-heads-tails
 * @fileoverview Detect and (recursively) remove head and tail wrappings around the input string
 * @version 6.0.11
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-duplicate-heads-tails/}
 */

import w from"lodash.isplainobject";import{arrayiffy as p}from"arrayiffy-if-string";import{matchLeftIncl as y,matchRightIncl as h}from"string-match-left-right";import{Ranges as S}from"ranges-push";import{rApply as R}from"ranges-apply";import{trimSpaces as b}from"string-trim-spaces-only";var k="6.0.11";var L=k,A={heads:["{{"],tails:["}}"]};function P(t,$){let T=Object.prototype.hasOwnProperty;if(t===void 0)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if(typeof t!="string")return t;if($&&!w($))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof $}!`);let i={...$};if(i&&T.call(i,"heads"))if(p(i.heads).every(e=>typeof e=="string"||Array.isArray(e)))typeof i.heads=="string"&&(i.heads=p(i.heads));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The opts.heads contains elements which are not string-type!");if(i&&T.call(i,"tails"))if(p(i.tails).every(e=>typeof e=="string"||Array.isArray(e)))typeof i.tails=="string"&&(i.tails=p(i.tails));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The opts.tails contains elements which are not string-type!");let E=b(t).res;if(E.length===0)return t;t=E;let r={...A,...i};r.heads=r.heads.map(e=>e.trim()),r.tails=r.tails.map(e=>e.trim());let f=!1,D=!1,g=new S({limitToBeAddedWhitespace:!0}),s=new S({limitToBeAddedWhitespace:!0}),a=!0,u=!0,d="";function O(e,c){let n;return h(e,0,c.heads,{trimBeforeMatching:!0,cb:(o,m,l)=>(n=l,!0)})&&h(e,n,c.tails,{trimBeforeMatching:!0,cb:(o,m,l)=>(n=l,!0)})?e.slice(n):e}for(;t!==O(t,r);)t=b(O(t,r)).res;function N(e,c){let n;return!y(e,e.length-1,c.tails,{trimBeforeMatching:!0,cb:(o,m,l)=>(n=l,!0)})||!n?e:y(e,n,c.heads,{trimBeforeMatching:!0,cb:(o,m,l)=>(n=l,!0)})?e.slice(0,n+1):e}for(;t!==N(t,r);)t=b(N(t,r)).res;if(!r.heads.length||!h(t,0,r.heads,{trimBeforeMatching:!0})||!r.tails.length||!y(t,t.length-1,r.tails,{trimBeforeMatching:!0}))return b(t).res;for(let e=0,c=t.length;e<c;e++)if(t[e].trim()!==""){let n;if(h(t,e,r.heads,{trimBeforeMatching:!0,cb:(o,m,l)=>(n=l,!0)})&&n){u=!0,a&&(a=!0);let o;h(t,n,r.tails,{trimBeforeMatching:!0,cb:(l,J,I)=>(o=I,!0)})&&g.push(e,o),s.current()&&f&&d!=="tails"&&g.push(s.current()),f||s.current()&&(g.push(s.current()),s.wipe()),s.push(e,n),d="heads",e=n-1;continue}if(h(t,e,r.tails,{trimBeforeMatching:!0,cb:(o,m,l)=>(n=Number.isInteger(l)?l:t.length,!0)})&&n){u=!0,a?(d==="heads"&&s.wipe(),a=!1):s.push(e,n),d="tails",e=n-1;continue}a&&(a=!0),u&&!f?(f=!0,u=!1):u&&!D?(D=!0,a=!0,u=!1,d==="heads"&&s.wipe()):u&&D&&s.wipe()}return s.current()&&g.push(s.current()),g.current()?R(t,g.current()).trim():t.trim()}export{A as defaults,P as remDup,L as version};
